summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--ChangeLog9
-rw-r--r--modules/mbstowcs-tests37
-rw-r--r--tests/test-mbstowcs.c254
-rwxr-xr-xtests/test-mbstowcs1.sh15
-rwxr-xr-xtests/test-mbstowcs2.sh15
-rwxr-xr-xtests/test-mbstowcs3.sh15
-rwxr-xr-xtests/test-mbstowcs4.sh15
-rwxr-xr-xtests/test-mbstowcs5.sh9
8 files changed, 369 insertions, 0 deletions
diff --git a/ChangeLog b/ChangeLog
index bc7372479c..e3d94c501e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,14 @@
2023-03-30 Bruno Haible <bruno@clisp.org>
+ mbstowcs: Add tests.
+ * tests/test-mbstowcs1.sh: New file, based on tests/test-mbsrtowcs1.sh.
+ * tests/test-mbstowcs2.sh: New file, based on tests/test-mbsrtowcs2.sh.
+ * tests/test-mbstowcs3.sh: New file, based on tests/test-mbsrtowcs3.sh.
+ * tests/test-mbstowcs4.sh: New file, based on tests/test-mbsrtowcs4.sh.
+ * tests/test-mbstowcs5.sh: New file, based on tests/test-mbsrtowcs5.sh.
+ * tests/test-mbstowcs.c: New file, based on tests/test-mbsrtowcs.c.
+ * modules/mbstowcs-tests: New file, based on modules/mbsrtowcs-tests.
+
mbstowcs: New module.
* lib/stdlib.in.h (mbstowcs): New declaration.
* lib/mbstowcs.c: New file, based on lib/mbstoc32s.c.
diff --git a/modules/mbstowcs-tests b/modules/mbstowcs-tests
new file mode 100644
index 0000000000..a780be2c4e
--- /dev/null
+++ b/modules/mbstowcs-tests
@@ -0,0 +1,37 @@
+Files:
+tests/test-mbstowcs1.sh
+tests/test-mbstowcs2.sh
+tests/test-mbstowcs3.sh
+tests/test-mbstowcs4.sh
+tests/test-mbstowcs5.sh
+tests/test-mbstowcs.c
+tests/signature.h
+tests/macros.h
+m4/locale-fr.m4
+m4/locale-ja.m4
+m4/locale-zh.m4
+m4/codeset.m4
+
+Depends-on:
+mbrtowc
+mbsinit
+wctob
+setlocale
+
+configure.ac:
+gt_LOCALE_FR
+gt_LOCALE_FR_UTF8
+gt_LOCALE_JA
+gt_LOCALE_ZH_CN
+
+Makefile.am:
+TESTS += \
+ test-mbstowcs1.sh test-mbstowcs2.sh test-mbstowcs3.sh test-mbstowcs4.sh \
+ test-mbstowcs5.sh
+TESTS_ENVIRONMENT += \
+ LOCALE_FR='@LOCALE_FR@' \
+ LOCALE_FR_UTF8='@LOCALE_FR_UTF8@' \
+ LOCALE_JA='@LOCALE_JA@' \
+ LOCALE_ZH_CN='@LOCALE_ZH_CN@'
+check_PROGRAMS += test-mbstowcs
+test_mbstowcs_LDADD = $(LDADD) $(SETLOCALE_LIB) $(MBRTOWC_LIB)
diff --git a/tests/test-mbstowcs.c b/tests/test-mbstowcs.c
new file mode 100644
index 0000000000..a33511a07d
--- /dev/null
+++ b/tests/test-mbstowcs.c
@@ -0,0 +1,254 @@
+/* Test of conversion of string to wide string.
+ Copyright (C) 2008-2023 Free Software Foundation, Inc.
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <https://www.gnu.org/licenses/>. */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2008. */
+
+#include <config.h>
+
+#include <stdlib.h>
+
+#include "signature.h"
+SIGNATURE_CHECK (mbstowcs, size_t, (wchar_t *, const char *, size_t));
+
+#include <locale.h>
+#include <stdio.h>
+#include <string.h>
+#include <wchar.h>
+
+#include "macros.h"
+
+int
+main (int argc, char *argv[])
+{
+ wchar_t wc;
+ size_t ret;
+
+ /* configure should already have checked that the locale is supported. */
+ if (setlocale (LC_ALL, "") == NULL)
+ return 1;
+
+ /* Test NUL byte input. */
+ {
+ const char *src;
+
+ src = "";
+ ret = mbstowcs (NULL, src, 0);
+ ASSERT (ret == 0);
+
+ src = "";
+ ret = mbstowcs (NULL, src, 1);
+ ASSERT (ret == 0);
+
+ wc = (wchar_t) 0xBADFACE;
+ src = "";
+ ret = mbstowcs (&wc, src, 0);
+ ASSERT (ret == 0);
+ ASSERT (wc == (wchar_t) 0xBADFACE);
+
+ wc = (wchar_t) 0xBADFACE;
+ src = "";
+ ret = mbstowcs (&wc, src, 1);
+ ASSERT (ret == 0);
+ ASSERT (wc == 0);
+ }
+
+ if (argc > 1)
+ {
+ int unlimited;
+
+ for (unlimited = 0; unlimited < 2; unlimited++)
+ {
+ #define BUFSIZE 10
+ wchar_t buf[BUFSIZE];
+ const char *src;
+
+ {
+ size_t i;
+ for (i = 0; i < BUFSIZE; i++)
+ buf[i] = (wchar_t) 0xBADFACE;
+ }
+
+ switch (argv[1][0])
+ {
+ case '1':
+ /* Locale encoding is ISO-8859-1 or ISO-8859-15. */
+ {
+ char input[] = "B\374\337er"; /* "Büßer" */
+
+ src = input + 1;
+ ret = mbstowcs (NULL, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == 4);
+
+ src = input + 1;
+ ret = mbstowcs (buf, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == (unlimited ? 4 : 1));
+ ASSERT (wctob (buf[0]) == (unsigned char) '\374');
+ if (unlimited)
+ {
+ ASSERT (wctob (buf[1]) == (unsigned char) '\337');
+ ASSERT (buf[2] == 'e');
+ ASSERT (buf[3] == 'r');
+ ASSERT (buf[4] == 0);
+ ASSERT (buf[5] == (wchar_t) 0xBADFACE);
+ }
+ else
+ ASSERT (buf[1] == (wchar_t) 0xBADFACE);
+ }
+ break;
+
+ case '2':
+ /* Locale encoding is UTF-8. */
+ {
+ char input[] = "B\303\274\303\237er"; /* "Büßer" */
+
+ src = input + 1;
+ ret = mbstowcs (NULL, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == 4);
+
+ src = input + 1;
+ ret = mbstowcs (buf, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == (unlimited ? 4 : 1));
+ ASSERT (wctob (buf[0]) == EOF);
+ ASSERT (wctob (buf[1]) == EOF);
+ if (unlimited)
+ {
+ ASSERT (buf[2] == 'e');
+ ASSERT (buf[3] == 'r');
+ ASSERT (buf[4] == 0);
+ ASSERT (buf[5] == (wchar_t) 0xBADFACE);
+ }
+ else
+ ASSERT (buf[2] == (wchar_t) 0xBADFACE);
+ }
+ break;
+
+ case '3':
+ /* Locale encoding is EUC-JP. */
+ {
+ char input[] = "<\306\374\313\334\270\354>"; /* "<日本語>" */
+
+ src = input + 1;
+ ret = mbstowcs (NULL, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == 4);
+
+ src = input + 1;
+ ret = mbstowcs (buf, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == (unlimited ? 4 : 1));
+ ASSERT (wctob (buf[0]) == EOF);
+ ASSERT (wctob (buf[1]) == EOF);
+ ASSERT (wctob (buf[2]) == EOF);
+ if (unlimited)
+ {
+ ASSERT (buf[3] == '>');
+ ASSERT (buf[4] == 0);
+ ASSERT (buf[5] == (wchar_t) 0xBADFACE);
+ }
+ else
+ ASSERT (buf[3] == (wchar_t) 0xBADFACE);
+ }
+ break;
+
+ case '4':
+ /* Locale encoding is GB18030. */
+ {
+ char input[] = "B\250\271\201\060\211\070er"; /* "Büßer" */
+
+ src = input + 1;
+ ret = mbstowcs (NULL, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == 4);
+
+ src = input + 1;
+ ret = mbstowcs (buf, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == (unlimited ? 4 : 1));
+ ASSERT (wctob (buf[0]) == EOF);
+ if (unlimited)
+ {
+ ASSERT (wctob (buf[1]) == EOF);
+ ASSERT (buf[2] == 'e');
+ ASSERT (buf[3] == 'r');
+ ASSERT (buf[4] == 0);
+ ASSERT (buf[5] == (wchar_t) 0xBADFACE);
+ }
+ else
+ ASSERT (buf[1] == (wchar_t) 0xBADFACE);
+ }
+ break;
+
+ case '5':
+ /* C or POSIX locale. */
+ {
+ char input[] = "n/a";
+
+ src = input;
+ ret = mbstowcs (NULL, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == 3);
+
+ src = input;
+ ret = mbstowcs (buf, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == (unlimited ? 3 : 1));
+ ASSERT (buf[0] == 'n');
+ if (unlimited)
+ {
+ ASSERT (buf[1] == '/');
+ ASSERT (buf[2] == 'a');
+ ASSERT (buf[3] == 0);
+ ASSERT (buf[4] == (wchar_t) 0xBADFACE);
+ }
+ else
+ ASSERT (buf[1] == (wchar_t) 0xBADFACE);
+ }
+ {
+ int c;
+ char input[2];
+
+ for (c = 0; c < 0x100; c++)
+ if (c != 0)
+ {
+ /* We are testing all nonnull bytes. */
+ input[0] = c;
+ input[1] = '\0';
+
+ src = input;
+ ret = mbstowcs (NULL, src, unlimited ? BUFSIZE : 1);
+ ASSERT (ret == 1);
+
+ buf[0] = buf[1] = (wchar_t) 0xBADFACE;
+ src = input;
+ ret = mbstowcs (buf, src, unlimited ? BUFSIZE : 1);
+ /* POSIX:2018 says: "In the POSIX locale an [EILSEQ] error
+ cannot occur since all byte values are valid characters." */
+ ASSERT (ret == 1);
+ if (c < 0x80)
+ /* c is an ASCII character. */
+ ASSERT (buf[0] == c);
+ else
+ /* On most platforms, the bytes 0x80..0xFF map to U+0080..U+00FF.
+ But on musl libc, the bytes 0x80..0xFF map to U+DF80..U+DFFF. */
+ ASSERT (buf[0] == (btowc (c) == 0xDF00 + c ? btowc (c) : c));
+ }
+ }
+ break;
+
+ default:
+ return 1;
+ }
+ }
+
+ return 0;
+ }
+
+ return 1;
+}
diff --git a/tests/test-mbstowcs1.sh b/tests/test-mbstowcs1.sh
new file mode 100755
index 0000000000..57f82d80fc
--- /dev/null
+++ b/tests/test-mbstowcs1.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+# Test in an ISO-8859-1 or ISO-8859-15 locale.
+: "${LOCALE_FR=fr_FR}"
+if test $LOCALE_FR = none; then
+ if test -f /usr/bin/localedef; then
+ echo "Skipping test: no traditional french locale is installed"
+ else
+ echo "Skipping test: no traditional french locale is supported"
+ fi
+ exit 77
+fi
+
+LC_ALL=$LOCALE_FR \
+${CHECKER} ./test-mbstowcs${EXEEXT} 1
diff --git a/tests/test-mbstowcs2.sh b/tests/test-mbstowcs2.sh
new file mode 100755
index 0000000000..311b9b5f27
--- /dev/null
+++ b/tests/test-mbstowcs2.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+# Test whether a specific UTF-8 locale is installed.
+: "${LOCALE_FR_UTF8=fr_FR.UTF-8}"
+if test $LOCALE_FR_UTF8 = none; then
+ if test -f /usr/bin/localedef; then
+ echo "Skipping test: no french Unicode locale is installed"
+ else
+ echo "Skipping test: no french Unicode locale is supported"
+ fi
+ exit 77
+fi
+
+LC_ALL=$LOCALE_FR_UTF8 \
+${CHECKER} ./test-mbstowcs${EXEEXT} 2
diff --git a/tests/test-mbstowcs3.sh b/tests/test-mbstowcs3.sh
new file mode 100755
index 0000000000..ebaada5599
--- /dev/null
+++ b/tests/test-mbstowcs3.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+# Test whether a specific EUC-JP locale is installed.
+: "${LOCALE_JA=ja_JP}"
+if test $LOCALE_JA = none; then
+ if test -f /usr/bin/localedef; then
+ echo "Skipping test: no traditional japanese locale is installed"
+ else
+ echo "Skipping test: no traditional japanese locale is supported"
+ fi
+ exit 77
+fi
+
+LC_ALL=$LOCALE_JA \
+${CHECKER} ./test-mbstowcs${EXEEXT} 3
diff --git a/tests/test-mbstowcs4.sh b/tests/test-mbstowcs4.sh
new file mode 100755
index 0000000000..86da562f02
--- /dev/null
+++ b/tests/test-mbstowcs4.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+# Test whether a specific GB18030 locale is installed.
+: "${LOCALE_ZH_CN=zh_CN.GB18030}"
+if test $LOCALE_ZH_CN = none; then
+ if test -f /usr/bin/localedef; then
+ echo "Skipping test: no transitional chinese locale is installed"
+ else
+ echo "Skipping test: no transitional chinese locale is supported"
+ fi
+ exit 77
+fi
+
+LC_ALL=$LOCALE_ZH_CN \
+${CHECKER} ./test-mbstowcs${EXEEXT} 4
diff --git a/tests/test-mbstowcs5.sh b/tests/test-mbstowcs5.sh
new file mode 100755
index 0000000000..ae2477ed01
--- /dev/null
+++ b/tests/test-mbstowcs5.sh
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+# Test whether the POSIX locale has encoding errors.
+LC_ALL=C \
+${CHECKER} ./test-mbstowcs${EXEEXT} 5 || exit 1
+LC_ALL=POSIX \
+${CHECKER} ./test-mbstowcs${EXEEXT} 5 || exit 1
+
+exit 0